## Contributing to Secure LS

We love your input! We want to make contributing to this project as easy and transparent as possible, whether it's:

- Reporting a bug
- Discussing the current state of the code
- Submitting a fix
- Proposing new features

### We Use [Github Flow](https://guides.github.com/introduction/flow/index.html), So All Code Changes Happen Through Pull Requests

Pull requests are the best way to propose changes to the codebase (we use [Github Flow](https://guides.github.com/introduction/flow/index.html)). We actively welcome your pull requests:

1. Fork the repo and create your branch from `master`.
2. If you've added code that should be tested, add tests.
3. Ensure the test suite passes.
4. Make sure your code lints.
5. Open a pull request!

### Any contributions you make will be under the MIT Software License

When you submit code changes, your submissions are understood to be under the same [MIT License](https://opensource.org/license/mit) that covers the project. Feel free to contact the maintainers if that's a concern.

### Report bugs using GitHub issues

We use GitHub issues to track public bugs. Report a bug by [opening a new issue](https://github.com/softvar/secure-ls/issues); it's that easy!

**Note**: Write bug reports with detail, background, and sample code

**Great Bug Reports** tend to have:

- A quick summary and/or background
- Steps to reproduce
  - Be specific!
  - Give sample code if you can.
- What you expected would happen
- What actually happens
- Notes (possibly including why you think this might be happening, or stuff you tried that didn't work)

### Use a Consistent Coding Style

We use [prettier](https://prettier.io/) for auto-formatting and consistent coding style among developers.

### License

By contributing, you agree that your contributions will be licensed under its MIT License.
